##// END OF EJS Templates
syntax
Unknown -
r300:ca18da28a529
parent child
Show More
@@ -1,765 +1,766
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 # Debian release
46 # Debian release
47 RELEASE=${RELEASE:=jessie}
47 RELEASE=${RELEASE:=jessie}
48
48
49 #Kernel Branch
49 #Kernel Branch
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
51
51
52 # URLs
52 # URLs
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59
59
60 # Build directories
60 # Build directories
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 BUILDDIR="${BASEDIR}/build"
62 BUILDDIR="${BASEDIR}/build"
63
63
64 # Prepare date string for default image file name
64 # Prepare date string for default image file name
65 DATE="$(date +%Y-%m-%d)"
65 DATE="$(date +%Y-%m-%d)"
66 if [ -z "$KERNEL_BRANCH" ] ; then
66 if [ -z "$KERNEL_BRANCH" ] ; then
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 else
68 else
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 fi
70 fi
71
71
72 # Chroot directories
72 # Chroot directories
73 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
74 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
75 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
76 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
77 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79
79
80 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82
82
83 # General settings
83 # General settings
84 SET_ARCH=${SET_ARCH}
84 SET_ARCH=${SET_ARCH}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
91
91
92 # Keyboard settings
92 # Keyboard settings
93 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97
97
98 # Network settings (DHCP)
98 # Network settings (DHCP)
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100
100
101 # Network settings (static)
101 # Network settings (static)
102 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
109
109
110 # APT settings
110 # APT settings
111 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113
113
114 # Feature settings
114 # Feature settings
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
127 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
130 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133
133
134 # SSH settings
134 # SSH settings
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140
140
141 # Advanced settings
141 # Advanced settings
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
154
154
155 # Kernel compilation settings
155 # Kernel compilation settings
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
156 BUILD_KERNEL=${BUILD_KERNEL:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
164
164
165 # Kernel compilation from source directory settings
165 # Kernel compilation from source directory settings
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
170
170
171 # Reduce disk usage settings
171 # Reduce disk usage settings
172 REDUCE_APT=${REDUCE_APT:=true}
172 REDUCE_APT=${REDUCE_APT:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
175 REDUCE_VIM=${REDUCE_VIM:=false}
175 REDUCE_VIM=${REDUCE_VIM:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
180
180
181 # Encrypted filesystem settings
181 # Encrypted filesystem settings
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
187
187
188 # Chroot scripts directory
188 # Chroot scripts directory
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190
190
191 # Packages required in the chroot build environment
191 # Packages required in the chroot build environment
192 APT_INCLUDES=${APT_INCLUDES:=""}
192 APT_INCLUDES=${APT_INCLUDES:=""}
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
194
194
195 # Packages required for bootstrapping
195 # Packages required for bootstrapping
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
197 MISSING_PACKAGES=""
197 MISSING_PACKAGES=""
198
198
199 # Packages installed for c/c++ build environment in chroot (keep empty)
199 # Packages installed for c/c++ build environment in chroot (keep empty)
200 COMPILER_PACKAGES=""
200 COMPILER_PACKAGES=""
201
201
202 set +x
202 set +x
203
203
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 if [ -n "$SET_ARCH" ]
205 if [ -n "$SET_ARCH" ] ; then
206 echo "Setting Architecture specific settings"
206 echo "Setting Architecture specific settings"
207 ##################################
207 ##################################
208 # 64 bit config
208 # 64 bit config
209 ##################################
209 ##################################
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
211 echo "64 bit mode selected - Setting up enviroment"
211 echo "64 bit mode selected - Setting up enviroment"
212 # 64 bit depended settings
212 # 64 bit depended settings
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219
219
220 # RPI 3 serie specific settings
220 # RPI 3 serie specific settings
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
223
223
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
226 else
226 else
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
228 exit 1
228 exit 1
229 fi
229 fi
230
230
231 ##################################
231 ##################################
232 # 32 bit config
232 # 32 bit config
233 ##################################
233 ##################################
234 if [ "$SET_ARCH" = 32 ] ; then
234 if [ "$SET_ARCH" = 32 ] ; then
235 echo "32 bit mode selected - Setting up enviroment"
235 echo "32 bit mode selected - Setting up enviroment"
236 #General 32bit configuration
236 #General 32bit configuration
237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
237 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
238 KERNEL_ARCH=${KERNEL_ARCH:=arm}
239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
239 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
240
240
241 #Raspberry setting grouped by board compability
241 #Raspberry setting grouped by board compability
242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
242 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
243 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
244 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
245 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
246 RELEASE_ARCH=${RELEASE_ARCH:=armel}
247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
247 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
248 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
249 fi
249 fi
250 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
250 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
251 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
251 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
252 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
252 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
253 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
253 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
254 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
254 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
255 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
255 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
256 fi
256 fi
257 fi
258
257
259 #Device specific configuration
258 #Device specific configuration
260 case "$RPI_MODEL" in
259 case "$RPI_MODEL" in
261 0)
260 0)
262 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
261 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
263 1)
262 1)
264 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
265 1P)
264 1P)
266 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
267 2)
266 2)
268 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
267 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
269 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
268 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
270 #Precompiled Kernel rpi2
269 #Precompiled Kernel rpi2
271 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
270 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
272 ;;
271 ;;
273 3)
272 3)
274 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
273 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
275 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
274 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
276 ;;
275 ;;
277 3P)
276 3P)
278 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
277 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
279 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
278 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
280 ;;
279 ;;
281 *)
280 *)
282 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
281 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
283 exit 1
282 exit 1
284 ;;
283 ;;
285 esac
284 esac
285 #end 32 bit
286 fi
286 #SET_ARCH not set
287 #SET_ARCH not set
287 else
288 else
288 echo "error: Please set '32' or '64' as value for SET_ARCH"
289 echo "error: Please set '32' or '64' as value for SET_ARCH"
289 exit 1
290 exit 1
290 fi
291 fi
291
292
292 # Check if the internal wireless interface is supported by the RPi model
293 # Check if the internal wireless interface is supported by the RPi model
293 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
294 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
294 echo "error: The selected Raspberry Pi model has no internal wireless interface"
295 echo "error: The selected Raspberry Pi model has no internal wireless interface"
295 exit 1
296 exit 1
296 else
297 else
297 echo "Raspberry Pi model"
298 echo "Raspberry Pi model"
298 fi
299 fi
299
300
300 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
301 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
301 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
302 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
302 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
303 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
303 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
304 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
304 exit 1
305 exit 1
305 fi
306 fi
306 fi
307 fi
307
308
308 # Add libncurses5 to enable kernel menuconfig
309 # Add libncurses5 to enable kernel menuconfig
309 if [ "$KERNEL_MENUCONFIG" = true ] ; then
310 if [ "$KERNEL_MENUCONFIG" = true ] ; then
310 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
311 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
311 fi
312 fi
312
313
313 # Add ccache compiler cache for (faster) kernel cross (re)compilation
314 # Add ccache compiler cache for (faster) kernel cross (re)compilation
314 if [ "$KERNEL_CCACHE" = true ] ; then
315 if [ "$KERNEL_CCACHE" = true ] ; then
315 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
316 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
316 fi
317 fi
317
318
318 # Add cryptsetup package to enable filesystem encryption
319 # Add cryptsetup package to enable filesystem encryption
319 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
320 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
320 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
321 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
321 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
322 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
322
323
323 if [ -z "$CRYPTFS_PASSWORD" ] ; then
324 if [ -z "$CRYPTFS_PASSWORD" ] ; then
324 echo "error: no password defined (CRYPTFS_PASSWORD)!"
325 echo "error: no password defined (CRYPTFS_PASSWORD)!"
325 exit 1
326 exit 1
326 fi
327 fi
327 ENABLE_INITRAMFS=true
328 ENABLE_INITRAMFS=true
328 fi
329 fi
329
330
330 # Add initramfs generation tools
331 # Add initramfs generation tools
331 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
332 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
332 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
333 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
333 fi
334 fi
334
335
335 # Add device-tree-compiler required for building the U-Boot bootloader
336 # Add device-tree-compiler required for building the U-Boot bootloader
336 if [ "$ENABLE_UBOOT" = true ] ; then
337 if [ "$ENABLE_UBOOT" = true ] ; then
337 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
338 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
338 fi
339 fi
339
340
340 # Check if root SSH (v2) public key file exists
341 # Check if root SSH (v2) public key file exists
341 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
342 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
342 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
343 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
343 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
344 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
344 exit 1
345 exit 1
345 fi
346 fi
346 fi
347 fi
347
348
348 # Check if $USER_NAME SSH (v2) public key file exists
349 # Check if $USER_NAME SSH (v2) public key file exists
349 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
350 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
350 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
351 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
351 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
352 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
352 exit 1
353 exit 1
353 fi
354 fi
354 fi
355 fi
355
356
356 # Check if all required packages are installed on the build system
357 # Check if all required packages are installed on the build system
357 for package in $REQUIRED_PACKAGES ; do
358 for package in $REQUIRED_PACKAGES ; do
358 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
359 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
359 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
360 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
360 fi
361 fi
361 done
362 done
362
363
363 # If there are missing packages ask confirmation for install, or exit
364 # If there are missing packages ask confirmation for install, or exit
364 if [ -n "$MISSING_PACKAGES" ] ; then
365 if [ -n "$MISSING_PACKAGES" ] ; then
365 echo "the following packages needed by this script are not installed:"
366 echo "the following packages needed by this script are not installed:"
366 echo "$MISSING_PACKAGES"
367 echo "$MISSING_PACKAGES"
367
368
368 echo -n "\ndo you want to install the missing packages right now? [y/n] "
369 echo -n "\ndo you want to install the missing packages right now? [y/n] "
369 read confirm
370 read confirm
370 [ "$confirm" != "y" ] && exit 1
371 [ "$confirm" != "y" ] && exit 1
371
372
372 # Make sure all missing required packages are installed
373 # Make sure all missing required packages are installed
373 apt-get -qq -y install ${MISSING_PACKAGES}
374 apt-get -qq -y install ${MISSING_PACKAGES}
374 fi
375 fi
375
376
376 # Check if ./bootstrap.d directory exists
377 # Check if ./bootstrap.d directory exists
377 if [ ! -d "./bootstrap.d/" ] ; then
378 if [ ! -d "./bootstrap.d/" ] ; then
378 echo "error: './bootstrap.d' required directory not found!"
379 echo "error: './bootstrap.d' required directory not found!"
379 exit 1
380 exit 1
380 fi
381 fi
381
382
382 # Check if ./files directory exists
383 # Check if ./files directory exists
383 if [ ! -d "./files/" ] ; then
384 if [ ! -d "./files/" ] ; then
384 echo "error: './files' required directory not found!"
385 echo "error: './files' required directory not found!"
385 exit 1
386 exit 1
386 fi
387 fi
387
388
388 # Check if specified KERNELSRC_DIR directory exists
389 # Check if specified KERNELSRC_DIR directory exists
389 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
390 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
390 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
391 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
391 exit 1
392 exit 1
392 fi
393 fi
393
394
394 # Check if specified UBOOTSRC_DIR directory exists
395 # Check if specified UBOOTSRC_DIR directory exists
395 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
396 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
396 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
397 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
397 exit 1
398 exit 1
398 fi
399 fi
399
400
400 # Check if specified FBTURBOSRC_DIR directory exists
401 # Check if specified FBTURBOSRC_DIR directory exists
401 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
402 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
402 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
403 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
403 exit 1
404 exit 1
404 fi
405 fi
405
406
406 # Check if specified CHROOT_SCRIPTS directory exists
407 # Check if specified CHROOT_SCRIPTS directory exists
407 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
408 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
408 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
409 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
409 exit 1
410 exit 1
410 fi
411 fi
411
412
412 # Check if specified device mapping already exists (will be used by cryptsetup)
413 # Check if specified device mapping already exists (will be used by cryptsetup)
413 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
414 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
414 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
415 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
415 exit 1
416 exit 1
416 fi
417 fi
417
418
418 # Don't clobber an old build
419 # Don't clobber an old build
419 if [ -e "$BUILDDIR" ] ; then
420 if [ -e "$BUILDDIR" ] ; then
420 echo "error: directory ${BUILDDIR} already exists, not proceeding"
421 echo "error: directory ${BUILDDIR} already exists, not proceeding"
421 exit 1
422 exit 1
422 fi
423 fi
423
424
424 # Setup chroot directory
425 # Setup chroot directory
425 mkdir -p "${R}"
426 mkdir -p "${R}"
426
427
427 # Check if build directory has enough of free disk space >512MB
428 # Check if build directory has enough of free disk space >512MB
428 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
429 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
429 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
430 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
430 exit 1
431 exit 1
431 fi
432 fi
432
433
433 set -x
434 set -x
434
435
435 # Call "cleanup" function on various signals and errors
436 # Call "cleanup" function on various signals and errors
436 trap cleanup 0 1 2 3 6
437 trap cleanup 0 1 2 3 6
437
438
438 # Add required packages for the minbase installation
439 # Add required packages for the minbase installation
439 if [ "$ENABLE_MINBASE" = true ] ; then
440 if [ "$ENABLE_MINBASE" = true ] ; then
440 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
441 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
441 fi
442 fi
442
443
443 # Add required locales packages
444 # Add required locales packages
444 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
445 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
445 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
446 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
446 fi
447 fi
447
448
448 # Add parted package, required to get partprobe utility
449 # Add parted package, required to get partprobe utility
449 if [ "$EXPANDROOT" = true ] ; then
450 if [ "$EXPANDROOT" = true ] ; then
450 APT_INCLUDES="${APT_INCLUDES},parted"
451 APT_INCLUDES="${APT_INCLUDES},parted"
451 fi
452 fi
452
453
453 # Add dbus package, recommended if using systemd
454 # Add dbus package, recommended if using systemd
454 if [ "$ENABLE_DBUS" = true ] ; then
455 if [ "$ENABLE_DBUS" = true ] ; then
455 APT_INCLUDES="${APT_INCLUDES},dbus"
456 APT_INCLUDES="${APT_INCLUDES},dbus"
456 fi
457 fi
457
458
458 # Add iptables IPv4/IPv6 package
459 # Add iptables IPv4/IPv6 package
459 if [ "$ENABLE_IPTABLES" = true ] ; then
460 if [ "$ENABLE_IPTABLES" = true ] ; then
460 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
461 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
461 fi
462 fi
462
463
463 # Add openssh server package
464 # Add openssh server package
464 if [ "$ENABLE_SSHD" = true ] ; then
465 if [ "$ENABLE_SSHD" = true ] ; then
465 APT_INCLUDES="${APT_INCLUDES},openssh-server"
466 APT_INCLUDES="${APT_INCLUDES},openssh-server"
466 fi
467 fi
467
468
468 # Add alsa-utils package
469 # Add alsa-utils package
469 if [ "$ENABLE_SOUND" = true ] ; then
470 if [ "$ENABLE_SOUND" = true ] ; then
470 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
471 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
471 fi
472 fi
472
473
473 # Add rng-tools package
474 # Add rng-tools package
474 if [ "$ENABLE_HWRANDOM" = true ] ; then
475 if [ "$ENABLE_HWRANDOM" = true ] ; then
475 APT_INCLUDES="${APT_INCLUDES},rng-tools"
476 APT_INCLUDES="${APT_INCLUDES},rng-tools"
476 fi
477 fi
477
478
478 # Add fbturbo video driver
479 # Add fbturbo video driver
479 if [ "$ENABLE_FBTURBO" = true ] ; then
480 if [ "$ENABLE_FBTURBO" = true ] ; then
480 # Enable xorg package dependencies
481 # Enable xorg package dependencies
481 ENABLE_XORG=true
482 ENABLE_XORG=true
482 fi
483 fi
483
484
484 # Add user defined window manager package
485 # Add user defined window manager package
485 if [ -n "$ENABLE_WM" ] ; then
486 if [ -n "$ENABLE_WM" ] ; then
486 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
487 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
487
488
488 # Enable xorg package dependencies
489 # Enable xorg package dependencies
489 ENABLE_XORG=true
490 ENABLE_XORG=true
490 fi
491 fi
491
492
492 # Add xorg package
493 # Add xorg package
493 if [ "$ENABLE_XORG" = true ] ; then
494 if [ "$ENABLE_XORG" = true ] ; then
494 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
495 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
495 fi
496 fi
496
497
497 # Replace selected packages with smaller clones
498 # Replace selected packages with smaller clones
498 if [ "$ENABLE_REDUCE" = true ] ; then
499 if [ "$ENABLE_REDUCE" = true ] ; then
499 # Add levee package instead of vim-tiny
500 # Add levee package instead of vim-tiny
500 if [ "$REDUCE_VIM" = true ] ; then
501 if [ "$REDUCE_VIM" = true ] ; then
501 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
502 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
502 fi
503 fi
503
504
504 # Add dropbear package instead of openssh-server
505 # Add dropbear package instead of openssh-server
505 if [ "$REDUCE_SSHD" = true ] ; then
506 if [ "$REDUCE_SSHD" = true ] ; then
506 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
507 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
507 fi
508 fi
508 fi
509 fi
509
510
510 if [ "$RELEASE" != "jessie" ] ; then
511 if [ "$RELEASE" != "jessie" ] ; then
511 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
512 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
512 fi
513 fi
513
514
514 # Configure kernel sources if no KERNELSRC_DIR
515 # Configure kernel sources if no KERNELSRC_DIR
515 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
516 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
516 KERNELSRC_CONFIG=true
517 KERNELSRC_CONFIG=true
517 fi
518 fi
518
519
519 # Configure reduced kernel
520 # Configure reduced kernel
520 if [ "$KERNEL_REDUCE" = true ] ; then
521 if [ "$KERNEL_REDUCE" = true ] ; then
521 KERNELSRC_CONFIG=false
522 KERNELSRC_CONFIG=false
522 fi
523 fi
523
524
524 # Execute bootstrap scripts
525 # Execute bootstrap scripts
525 for SCRIPT in bootstrap.d/*.sh; do
526 for SCRIPT in bootstrap.d/*.sh; do
526 head -n 3 "$SCRIPT"
527 head -n 3 "$SCRIPT"
527 . "$SCRIPT"
528 . "$SCRIPT"
528 done
529 done
529
530
530 ## Execute custom bootstrap scripts
531 ## Execute custom bootstrap scripts
531 if [ -d "custom.d" ] ; then
532 if [ -d "custom.d" ] ; then
532 for SCRIPT in custom.d/*.sh; do
533 for SCRIPT in custom.d/*.sh; do
533 . "$SCRIPT"
534 . "$SCRIPT"
534 done
535 done
535 fi
536 fi
536
537
537 # Execute custom scripts inside the chroot
538 # Execute custom scripts inside the chroot
538 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
539 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
539 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
540 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
540 chroot_exec /bin/bash -x <<'EOF'
541 chroot_exec /bin/bash -x <<'EOF'
541 for SCRIPT in /chroot_scripts/* ; do
542 for SCRIPT in /chroot_scripts/* ; do
542 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
543 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
543 $SCRIPT
544 $SCRIPT
544 fi
545 fi
545 done
546 done
546 EOF
547 EOF
547 rm -rf "${R}/chroot_scripts"
548 rm -rf "${R}/chroot_scripts"
548 fi
549 fi
549
550
550 # Remove c/c++ build environment from the chroot
551 # Remove c/c++ build environment from the chroot
551 chroot_remove_cc
552 chroot_remove_cc
552
553
553 # Remove apt-utils
554 # Remove apt-utils
554 if [ "$RELEASE" = "jessie" ] ; then
555 if [ "$RELEASE" = "jessie" ] ; then
555 chroot_exec apt-get purge -qq -y --force-yes apt-utils
556 chroot_exec apt-get purge -qq -y --force-yes apt-utils
556 fi
557 fi
557
558
558 # Generate required machine-id
559 # Generate required machine-id
559 MACHINE_ID=$(dbus-uuidgen)
560 MACHINE_ID=$(dbus-uuidgen)
560 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
561 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
561 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
562 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
562
563
563 # APT Cleanup
564 # APT Cleanup
564 chroot_exec apt-get -y clean
565 chroot_exec apt-get -y clean
565 chroot_exec apt-get -y autoclean
566 chroot_exec apt-get -y autoclean
566 chroot_exec apt-get -y autoremove
567 chroot_exec apt-get -y autoremove
567
568
568 # Unmount mounted filesystems
569 # Unmount mounted filesystems
569 umount -l "${R}/proc"
570 umount -l "${R}/proc"
570 umount -l "${R}/sys"
571 umount -l "${R}/sys"
571
572
572 # Clean up directories
573 # Clean up directories
573 rm -rf "${R}/run/*"
574 rm -rf "${R}/run/*"
574 rm -rf "${R}/tmp/*"
575 rm -rf "${R}/tmp/*"
575
576
576 # Clean up files
577 # Clean up files
577 rm -f "${ETC_DIR}/ssh/ssh_host_*"
578 rm -f "${ETC_DIR}/ssh/ssh_host_*"
578 rm -f "${ETC_DIR}/dropbear/dropbear_*"
579 rm -f "${ETC_DIR}/dropbear/dropbear_*"
579 rm -f "${ETC_DIR}/apt/sources.list.save"
580 rm -f "${ETC_DIR}/apt/sources.list.save"
580 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
581 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
581 rm -f "${ETC_DIR}/*-"
582 rm -f "${ETC_DIR}/*-"
582 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
583 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
583 rm -f "${ETC_DIR}/resolv.conf"
584 rm -f "${ETC_DIR}/resolv.conf"
584 rm -f "${R}/root/.bash_history"
585 rm -f "${R}/root/.bash_history"
585 rm -f "${R}/var/lib/urandom/random-seed"
586 rm -f "${R}/var/lib/urandom/random-seed"
586 rm -f "${R}/initrd.img"
587 rm -f "${R}/initrd.img"
587 rm -f "${R}/vmlinuz"
588 rm -f "${R}/vmlinuz"
588 rm -f "${R}${QEMU_BINARY}"
589 rm -f "${R}${QEMU_BINARY}"
589
590
590 if [ "$ENABLE_QEMU" = true ] ; then
591 if [ "$ENABLE_QEMU" = true ] ; then
591 # Configure qemu compatible kernel
592 # Configure qemu compatible kernel
592 DTB_FILE=vexpress-v2p-ca15_a7.dtb
593 DTB_FILE=vexpress-v2p-ca15_a7.dtb
593 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
594 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
594 KERNEL_DEFCONFIG="vexpress_defconfig"
595 KERNEL_DEFCONFIG="vexpress_defconfig"
595 if [ "$KERNEL_MENUCONFIG" = false ] ; then
596 if [ "$KERNEL_MENUCONFIG" = false ] ; then
596 KERNEL_OLDDEFCONFIG=true
597 KERNEL_OLDDEFCONFIG=true
597 fi
598 fi
598
599
599 # Setup QEMU directory
600 # Setup QEMU directory
600 mkdir "${BASEDIR}/qemu"
601 mkdir "${BASEDIR}/qemu"
601
602
602 # Copy kernel image to QEMU directory
603 # Copy kernel image to QEMU directory
603 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
604 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
604
605
605 # Copy kernel config to QEMU directory
606 # Copy kernel config to QEMU directory
606 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
607 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
607
608
608 # Copy kernel dtbs to QEMU directory
609 # Copy kernel dtbs to QEMU directory
609 for dtb in "${BOOT_DIR}/"*.dtb ; do
610 for dtb in "${BOOT_DIR}/"*.dtb ; do
610 if [ -f "${dtb}" ] ; then
611 if [ -f "${dtb}" ] ; then
611 install_readonly "${dtb}" "${BASEDIR}/qemu/"
612 install_readonly "${dtb}" "${BASEDIR}/qemu/"
612 fi
613 fi
613 done
614 done
614
615
615 # Copy kernel overlays to QEMU directory
616 # Copy kernel overlays to QEMU directory
616 if [ -d "${BOOT_DIR}/overlays" ] ; then
617 if [ -d "${BOOT_DIR}/overlays" ] ; then
617 # Setup overlays dtbs directory
618 # Setup overlays dtbs directory
618 mkdir "${BASEDIR}/qemu/overlays"
619 mkdir "${BASEDIR}/qemu/overlays"
619
620
620 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
621 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
621 if [ -f "${dtb}" ] ; then
622 if [ -f "${dtb}" ] ; then
622 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
623 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
623 fi
624 fi
624 done
625 done
625 fi
626 fi
626
627
627 # Copy u-boot files to QEMU directory
628 # Copy u-boot files to QEMU directory
628 if [ "$ENABLE_UBOOT" = true ] ; then
629 if [ "$ENABLE_UBOOT" = true ] ; then
629 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
630 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
630 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
631 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
631 fi
632 fi
632 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
633 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
633 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
634 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
634 fi
635 fi
635 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
636 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
636 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
637 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
637 fi
638 fi
638 fi
639 fi
639
640
640 # Copy initramfs to QEMU directory
641 # Copy initramfs to QEMU directory
641 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
642 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
642 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
643 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
643 fi
644 fi
644 fi
645 fi
645
646
646 # Calculate size of the chroot directory in KB
647 # Calculate size of the chroot directory in KB
647 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
648 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
648
649
649 # Calculate the amount of needed 512 Byte sectors
650 # Calculate the amount of needed 512 Byte sectors
650 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
651 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
651 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
652 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
652 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
653 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
653
654
654 # The root partition is EXT4
655 # The root partition is EXT4
655 # This means more space than the actual used space of the chroot is used.
656 # This means more space than the actual used space of the chroot is used.
656 # As overhead for journaling and reserved blocks 35% are added.
657 # As overhead for journaling and reserved blocks 35% are added.
657 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
658 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
658
659
659 # Calculate required image size in 512 Byte sectors
660 # Calculate required image size in 512 Byte sectors
660 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
661 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
661
662
662 # Prepare image file
663 # Prepare image file
663 if [ "$ENABLE_SPLITFS" = true ] ; then
664 if [ "$ENABLE_SPLITFS" = true ] ; then
664 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
665 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
665 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
666 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
666 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
667 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
667 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
668 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
668
669
669 # Write firmware/boot partition tables
670 # Write firmware/boot partition tables
670 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
671 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
671 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
672 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
672 EOM
673 EOM
673
674
674 # Write root partition table
675 # Write root partition table
675 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
676 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
676 ${TABLE_SECTORS},${ROOT_SECTORS},83
677 ${TABLE_SECTORS},${ROOT_SECTORS},83
677 EOM
678 EOM
678
679
679 # Setup temporary loop devices
680 # Setup temporary loop devices
680 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
681 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
681 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
682 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
682 else # ENABLE_SPLITFS=false
683 else # ENABLE_SPLITFS=false
683 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
684 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
684 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
685 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
685
686
686 # Write partition table
687 # Write partition table
687 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
688 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
688 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
689 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
689 ${ROOT_OFFSET},${ROOT_SECTORS},83
690 ${ROOT_OFFSET},${ROOT_SECTORS},83
690 EOM
691 EOM
691
692
692 # Setup temporary loop devices
693 # Setup temporary loop devices
693 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
694 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
694 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
695 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
695 fi
696 fi
696
697
697 if [ "$ENABLE_CRYPTFS" = true ] ; then
698 if [ "$ENABLE_CRYPTFS" = true ] ; then
698 # Create dummy ext4 fs
699 # Create dummy ext4 fs
699 mkfs.ext4 "$ROOT_LOOP"
700 mkfs.ext4 "$ROOT_LOOP"
700
701
701 # Setup password keyfile
702 # Setup password keyfile
702 touch .password
703 touch .password
703 chmod 600 .password
704 chmod 600 .password
704 echo -n ${CRYPTFS_PASSWORD} > .password
705 echo -n ${CRYPTFS_PASSWORD} > .password
705
706
706 # Initialize encrypted partition
707 # Initialize encrypted partition
707 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
708 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
708
709
709 # Open encrypted partition and setup mapping
710 # Open encrypted partition and setup mapping
710 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
711 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
711
712
712 # Secure delete password keyfile
713 # Secure delete password keyfile
713 shred -zu .password
714 shred -zu .password
714
715
715 # Update temporary loop device
716 # Update temporary loop device
716 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
717 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
717
718
718 # Wipe encrypted partition (encryption cipher is used for randomness)
719 # Wipe encrypted partition (encryption cipher is used for randomness)
719 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
720 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
720 fi
721 fi
721
722
722 # Build filesystems
723 # Build filesystems
723 mkfs.vfat "$FRMW_LOOP"
724 mkfs.vfat "$FRMW_LOOP"
724 mkfs.ext4 "$ROOT_LOOP"
725 mkfs.ext4 "$ROOT_LOOP"
725
726
726 # Mount the temporary loop devices
727 # Mount the temporary loop devices
727 mkdir -p "$BUILDDIR/mount"
728 mkdir -p "$BUILDDIR/mount"
728 mount "$ROOT_LOOP" "$BUILDDIR/mount"
729 mount "$ROOT_LOOP" "$BUILDDIR/mount"
729
730
730 mkdir -p "$BUILDDIR/mount/boot/firmware"
731 mkdir -p "$BUILDDIR/mount/boot/firmware"
731 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
732 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
732
733
733 # Copy all files from the chroot to the loop device mount point directory
734 # Copy all files from the chroot to the loop device mount point directory
734 rsync -a "${R}/" "$BUILDDIR/mount/"
735 rsync -a "${R}/" "$BUILDDIR/mount/"
735
736
736 # Unmount all temporary loop devices and mount points
737 # Unmount all temporary loop devices and mount points
737 cleanup
738 cleanup
738
739
739 # Create block map file(s) of image(s)
740 # Create block map file(s) of image(s)
740 if [ "$ENABLE_SPLITFS" = true ] ; then
741 if [ "$ENABLE_SPLITFS" = true ] ; then
741 # Create block map files for "bmaptool"
742 # Create block map files for "bmaptool"
742 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
743 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
743 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
744 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
744
745
745 # Image was successfully created
746 # Image was successfully created
746 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
747 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
747 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
748 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
748 else
749 else
749 # Create block map file for "bmaptool"
750 # Create block map file for "bmaptool"
750 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
751 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
751
752
752 # Image was successfully created
753 # Image was successfully created
753 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
754 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
754
755
755 # Create qemu qcow2 image
756 # Create qemu qcow2 image
756 if [ "$ENABLE_QEMU" = true ] ; then
757 if [ "$ENABLE_QEMU" = true ] ; then
757 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
758 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
758 QEMU_SIZE=16G
759 QEMU_SIZE=16G
759
760
760 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
761 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
761 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
762 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
762
763
763 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
764 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
764 fi
765 fi
765 fi
766 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant